<div class="add-class-space">
    <block-ui message="Loading..."></block-ui>

    <h3 class="mb-3 mt-3" id="heading">
        {{ addItem ? "Add Class" : "Edit Class" }}
    </h3>

    <app-alert [message]="message" [type]="type" id="alert"></app-alert>

    <form class="" [formGroup]="classForm" autocomplete="off">
        <div class="form-group row">
            <div class="col-xl-3 col-lg-6">
                <div class="row">
                    <div class="col-xl-12 d-flex align-items-center">
                        <app-image-upload></app-image-upload>
                    </div>

                    <div class="col-xl-12">
                        <div class="row  ml-0 mr-0 justify-content-between align-items-center">
                            <h5>Select Class Colour</h5>
                            <kendo-colorpicker [format]="'hex'" class="mt-3 mb-3" [value]="selectedColour"
                                               (valueChange)="onColourChange($event)"></kendo-colorpicker>
                        </div>
                    </div>

                    <div class="col-xl-12">
                        <div class="row  ml-0 mr-0 justify-content-between align-items-center">
                            <h5>Apply to location</h5>
                            <kendo-switch formControlName="isAllowAllLocation" [onLabel]="'All'" [offLabel]="'Selected'"
                                          class="mt-3 mb-3 wide-switch"
                                          (valueChange)="allLocationChange($event)"></kendo-switch>
                        </div>
                    </div>

                    <div class="col-xl-12" *ngIf="classForm.get('isAllowAllLocation').value == false">
                        <span>Location*</span>
                    </div>

                    <!-- Location  -->
                    <div class="col-xl-12 d-flex align-items-center"
                         *ngIf="classForm.get('isAllowAllLocation').value == false">
                        <kendo-multiselect [data]="locationList" placeholder="Location Name"
                                           formControlName="locationName"
                                           [filterable]="true" [textField]="'locationName'" [valueField]="'id'"
                                           [disabled]="locationEnable"
                                           style="min-height: 104px" (valueChange)="onLocationChange($event)">
                        </kendo-multiselect>
                    </div>

                    <div class="col-xl-12">
                        <span>Speciality*</span>
                    </div>
                    <!-- speciality  -->
                    <div class="col-xl-12 d-flex align-items-center">
                        <kendo-multiselect [data]="groupedSpecialityData" placeholder="Speciality Name"
                                           formControlName="specialityName" [filterable]="true"
                                           [textField]="'specialityName'"
                                           [valueField]="'idAndLocationId'" style="min-height: 104px"
                                           [disabled]="specialityEnable"
                                           (valueChange)="onSpecialityChange($event)">
                        </kendo-multiselect>
                    </div>

                    <div class="col-xl-12">
                        <span>Practitioner*</span>
                    </div>
                    <!-- Practitioner  -->
                    <div class="col-xl-12 d-flex align-items-center">
                        <kendo-multiselect [data]="groupedPractitionerData" placeholder="Practitioner Name"
                                           formControlName="practitionerName" [filterable]="true"
                                           [textField]="'firstName'" style="min-height: 104px"
                                           [valueField]="'idAndSpecialityIdAndLocationId'"
                                           [disabled]="practitionerEnable"

                        >
                        </kendo-multiselect>

                        <!-- <mat-error *ngIf="classForm.get('practitionerName').hasError('required')">
                          This field is required
                        </mat-error> -->
                    </div>
                </div>
            </div>
            <div class="col-xl-6 col-lg-6 bg-white">
                <div class="row mt-3 pb-2 pl-3 pr-3">
                    <div class="col-xl-12 text-right pl-0 pr-0">
                        <span>Required</span>
                    </div>
                    <!-- Product Code  -->
                    <div class="col-xl-12 d-flex align-items-left pl-0 pr-0">
                        <mat-form-field [appearance]="apperance" class="full-width">
                            <mat-label>Class Code</mat-label>
                            <input matInput placeholder="Class Code" required formControlName="classCode" appCharLimit
                                   [frmGroup]="classForm" fcName="classCode" [max]="10">

                            <mat-error *ngIf="classForm.get('classCode').hasError('exceedLimit')">
                                {{classForm.get('classCode').getError('exceedLimit')}}
                            </mat-error>

                            <mat-error *ngIf="classForm.get('classCode').hasError('required')">
                                This field is required
                            </mat-error>

                        </mat-form-field>
                    </div>

                    <!-- Medicare Code  -->
                    <div class="col-xl-12 align-items-right pl-0 pr-0">
                        <mat-form-field [appearance]="apperance" class="full-width">
                            <mat-label>Medicare Code</mat-label>
                            <input matInput placeholder="Medicare Code" formControlName="medicareCode" appCharLimit
                                   appNoSpecChar
                                   [frmGroup]="classForm" fcName="medicareCode" [max]="5">

                            <mat-error *ngIf="classForm.get('medicareCode').hasError('exceedLimit')">
                                {{classForm.get('medicareCode').getError('exceedLimit')}}
                            </mat-error>

                        </mat-form-field>
                    </div>

                    <!-- DVA Code  -->
                    <div class="col-xl-12 align-items-right pl-0 pr-0">
                        <mat-form-field [appearance]="apperance" class="full-width">
                            <mat-label>DVA Code</mat-label>
                            <input matInput placeholder="DVA Code" formControlName="dvaCode" appCharLimit appNoSpecChar
                                   [frmGroup]="classForm"
                                   fcName="dvaCode" [max]="4">

                            <mat-error *ngIf="classForm.get('dvaCode').hasError('exceedLimit')">
                                {{classForm.get('dvaCode').getError('exceedLimit')}}
                            </mat-error>
                            <mat-error *ngIf="classForm.get('dvaCode').hasError('notZero')">
                                This field should not be zero.
                            </mat-error>

                        </mat-form-field>
                    </div>

                    <div class="col-xl-12 text-right pl-0 pr-0">
                        <span>Required</span>
                    </div>
                    <!-- Class Name  -->
                    <div class="col-xl-12 d-flex align-items-center pl-0 pr-0">
                        <mat-form-field [appearance]="apperance" class="full-width">
                            <mat-label>Class Name</mat-label>
                            <input matInput placeholder="Class Name" required formControlName="className" appCharLimit
                                   [frmGroup]="classForm" fcName="className" [max]="100">

                            <mat-error *ngIf="classForm.get('className').hasError('exceedLimit')">
                                {{classForm.get('className').getError('exceedLimit')}}
                            </mat-error>

                            <mat-error *ngIf="classForm.get('className').hasError('required')">
                                This field is required
                            </mat-error>
                        </mat-form-field>
                    </div>

                    <!-- Description  -->
                    <div class="col-xl-12 d-flex align-items-center pl-0 pr-0">
                        <mat-form-field [appearance]="apperance" class="full-width">
              <textarea matInput placeholder="Description*" formControlName="description" rows="3" appCharLimit
                        [frmGroup]="classForm" fcName="description" [max]="200"></textarea>

                            <mat-error *ngIf="classForm.get('description').hasError('exceedLimit')">
                                {{classForm.get('description').getError('exceedLimit')}}
                            </mat-error>

                            <mat-error *ngIf="classForm.get('description').hasError('required')">
                                This field is required
                            </mat-error>
                        </mat-form-field>
                    </div>


                    <!--          <div class="col-xl-6 pl-0 pr-0">-->
                    <!--            <span>Category*</span>-->
                    <!--          </div>-->
                    <div class="col-xl-12 text-right pl-0 pr-0">
                        <span>Required</span>
                    </div>

                    <!-- Category  -->
                    <div class="col-xl-12 d-block align-items-center kendo-dropdown-bottom pl-0 pr-0">
                        <mat-form-field [appearance]="apperance" class="full-width">
                            <mat-label>Category*</mat-label>
                            <app-add-new-dropdown [categoryId]="classCategoryParentId" [selectedId]="classCategoryId"
                                                  (appId)="appIdClassCategoryHandler($event)"></app-add-new-dropdown>
                        </mat-form-field>
                    </div>

                    <!-- Related Product(s)  -->

                    <div class="col-xl-6 pl-0 pr-0">
                        <span>Related Product(s)</span>
                    </div>
                    <div class="col-xl-12 d-flex align-items-center pl-0 pr-0">
                        <kendo-multiselect [data]="products" placeholder="Related Product(s)"
                                           formControlName="productName"
                                           style="height: 104px" [filterable]="true" [textField]="'productName'"
                                           [valueField]="'id'">
                        </kendo-multiselect>
                    </div>
                    <div class="col-xl-12 d-flex align-items-center pl-0 pr-0">
                        <mat-hint>
                            Select the product which are usually sold along with class.
                        </mat-hint>
                    </div>
                </div>
            </div>
            <div class="col-xl-3 col-lg-12">

                <div class="d-flex flex-wrap justify-content-start">
                    <div class="switch-bottom-space pr-3">
                        <h6 class="bold switch-name">Status</h6>
                        <kendo-switch class="wider-switch" formControlName="status" [onLabel]="'Active'"
                                      [offLabel]="'Inactive'">
                        </kendo-switch>
                    </div>
                    <div class="switch-bottom-space">
                        <h6 class="bold switch-name">Online Booking</h6>
                        <kendo-switch class="wider-switch" formControlName="onlineBooking" [onLabel]="'Enabled'"
                                      [offLabel]="'Disable'"></kendo-switch>
                    </div>
                </div>

                <br/>
                <mat-divider></mat-divider>
                <div class="col-xl-12 pl-0 pr-0">
                    <h4 class="mt-3 mb-3 bold d-flex align-items-center d-inline-block">
                        <mat-icon>stay_primary_portrait</mat-icon>
                        Session and Pricing
                    </h4>
                </div>

                <!-- Duration  -->
                <div class="col-xl-12 d-flex align-items-center pl-0 pr-0">
                    <mat-form-field [appearance]="apperance" class="ccc-mat-form-field">
                        <mat-label>Duration*</mat-label>
                        <input matInput placeholder="Duration" formControlName="duration" type="number" min="0"
                               appOnlyNumber
                               appCharLimit [frmGroup]="classForm" fcName="duration" [max]="5">

                        <mat-error *ngIf="classForm.get('duration').hasError('exceedLimit')">
                            {{classForm.get('duration').getError('exceedLimit')}}
                        </mat-error>
                        <mat-error *ngIf="classForm.get('duration').hasError('required')">
                            This field is required
                        </mat-error>

                    </mat-form-field>
                    <div class="align-center">Minutes</div>
                </div>

                <!-- Maximum Number -->
                <div class="col-xl-12 d-flex align-items-center pl-0 pr-0">
                    <mat-form-field [appearance]="apperance" class="ccc-mat-form-field">
                        <input matInput placeholder="Maximum Number" formControlName="maximumParticipants" type="number"
                               min="0"
                               appOnlyNumber [frmGroup]="classForm" fcName="maximumParticipants" appCharLimit/>

                        <mat-error *ngIf="classForm.get('maximumParticipants').hasError('required')">
                            This field is required
                        </mat-error>
                    </mat-form-field>
                    <div class="align-center">Participants*</div>
                </div>

                <!-- Standard Price  -->
                <div class="col-xl-12 d-flex align-items-center pl-0 pr-0">
                    <mat-form-field [appearance]="apperance" class="full-width">
                        <mat-label>Standard Price (AUD) *</mat-label>
                        <input matInput formControlName="standardPrice" type="number" min="0" appOnlyNumber
                               [frmGroup]="classForm" fcName="standardPrice" appCharLimit
                        />

                        <mat-error *ngIf="classForm.get('standardPrice').hasError('required')">
                            This field is required
                        </mat-error>
                    </mat-form-field>
                </div>

                <!-- Tax Type  -->
                <div class="col-xl-12 pl-0 pr-0">
                    <span>Tax Type*</span>
                </div>
                <div class="col-xl-12 d-flex align-items-center kendo-dropdown-bottom pl-0 pr-0">
                    <kendo-dropdownlist [data]="taxTypes" [valuePrimitive]="true" [textField]="'taxType'"
                                        [valueField]="'id'"
                                        formControlName="taxTypeId" [formControl]="classForm.get('taxTypeId')"
                                        (valueChange)="handleTaxTypeChange($event)"
                                        class="mat-form-field-infix cat-height"
                                        [frmGroup]="classForm" fcName="taxTypeId" appCharLimit
                    >
                    </kendo-dropdownlist>

                    <mat-error *ngIf="classForm.get('taxTypeId').hasError('required')">
                        This field is required
                    </mat-error>
                </div>

                <!-- Tax Option  -->

                <div *ngIf="taxOptionHide" class="col-xl-12 d-flex align-items-center radio-margin pl-0 pr-0">
                    Tax Option
                </div>
                <div *ngIf="taxOptionHide" class="col-xl-12 d-flex align-items-center pl-0 pr-0">
                    <mat-radio-group formControlName="taxOptionId" [frmGroup]="classForm" fcName="taxOptionId"
                                     appCharLimit>
                        <mat-radio-button class="radio-margin" value="1" [checked]="taxOptionSelected === 1">Inclusive
                        </mat-radio-button>
                        <mat-radio-button class="radio-margin" value="2" [checked]="taxOptionSelected === 2">Exclusive
                        </mat-radio-button>
                    </mat-radio-group>

                    <mat-error *ngIf="classForm.get('taxOptionId').hasError('required')">
                        This field is required
                    </mat-error>
                </div>

                <div *ngIf="concessionsEnable">
                    <div class="col-xl-12 pl-0 pr-0">
                        <br/>
                        <mat-divider></mat-divider>
                        <br/>
                    </div>

                    <div class="col-xl-12 d-flex align-items-center pl-0 pr-0">Concession price</div>
                    <div class="col-xl-12 d-flex align-items-center pl-0 pr-0">
                        <mat-hint>
                            Leaving the concession price blank means the standard price will be used.
                        </mat-hint>
                    </div>
                    <div class="concession-scroll">
                        <div *ngFor="let cl of concessionList" class="col-xl-12 d-flex align-items-center pl-0 pr-0">
                            <mat-form-field [appearance]="apperance" class="full-width">
                                <mat-label>{{ cl.concessionType }}({{ cl.locationName }})</mat-label>
                                <input matInput id="{{ cl.locationId }}{{ cl.concessionType }}" type="number"
                                       value="{{ cl.concessionAmount }}"/>
                            </mat-form-field>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </form>

    <div class="text-right control-row">
        <mat-divider class=""></mat-divider>
        <div class="pt-3">
            <button mat-stroked-button color="accent" class="mr-2" (click)="cancel()">Cancel</button>
            <button mat-raised-button color="accent" class="mr-3 wide footer-btn-customize" (click)="createClass()"
                    *appAccess="moduleName; lookFor: ['C', 'E']"
                    [disabled]="classForm.invalid || classCategoryId === 0">
                <div *ngIf="!submitting">Save</div>
                <div *ngIf="submitting">Saving...</div>
            </button>
        </div>
    </div>
</div>
